#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */

//Author: Hayo W.
//Date  : 14.10.2008

//Convertion tool to create minicom scripts from standard .flash files
//to upload firmware to the Welec DSO W20xxA via RS232.
//The script can be loaded with the minicom terminal program.

//I'm sorry about the german comments down there but I had no
//motivation to translate it afterwards and when I wrote it
//I didn't think that would publish it.
//You can use this program as you want to, it is free stuff.

//Installation:
//Call make in the current directory. The binary will be created in
//the same directory.
//Call ./flash2mcom <inputfile> <outputfile> to create the script


void usage() 
{
	printf("Convert flash file to minicom script.\n");
	printf("Please call it like this:\n");
	printf("./flash2mcom <inputfile> <outputfile>\n\n");
}


int main(int argc, char **argv) 
{
	int linecount=0, i=0;
        char codezeile[1024];

	FILE *in,*out;					//Dateipointer


	if(argc<3) {
	  usage();
	  return 1;
	}

	printf("Quelldatei öffnen\n");
	in = fopen(argv[1],"rt");			// öffnen der Quelldatei
							// zuweisung des Zeigers "in" auf den Stream
	if (in == NULL)					
	{printf("konnte Quelldatei nicht öffnen\n");
	 return(1);
	}						// wird angesprungen wenn Datei nicht
							// geöffnet werden konnte und fopen NULL zurückgibt
	else
	{						
		printf("Zieldatei öffnen\n\n");
		out= fopen(argv[2],"w+");		// öffnen der Zieldatei
		if (out == NULL)					
		{printf("konnte Zieldatei nicht öffnen\n");
		fclose(in);					//Quelldatei schließen da diese sonst geöffnet bleibt 
		return(1);
		}						// wird angesprungen wenn Datei nicht
								// geöffnet werden konnte und fopen NULL zurückgibt
	}

	if (in != NULL && out != NULL )			// Rückgabewert von "fopen" auf Fehler überprüfen
       	{                    				// wenn ungleich NULL dann ist Datei korrekt geöffnet

		fputs("timeout 65535\n",out);		// Timeoutanweisung schreiben
		
		while (feof(in)==0)       		// Überprüfung auf Dateiende
	       	{

		for(i=0;i<1024;i++){codezeile[i]='\0';}	// String löschen
		
		
		fgets(codezeile,1024,in);    		// Einlesen einer Zeile aus dem Stream auf den "in" zeigt
					  		// in das Feld codezeile
							// 1024 gibt die maximale Zeilenlänge an
					  		// wird vorher \n erreicht bricht fgets ab

		if(strstr(codezeile, "#")) continue;	// Kommentare überspringen

		if(!strstr(codezeile, "r") &&		// Nur Anweisungsblöcke weiter verarbeiten
                   !strstr(codezeile, "S") &&
                   !strstr(codezeile, "e")) continue;

		fputs("send ",out);			// Sendeaanweisung schreiben

		fputs(codezeile,out);			// Codezeile in die Ausgabedatei schreiben

		fputs("expect +\n",out);		// Warteanweisung schreiben (Warten auf den Prompt)

//		printf("%s",codezeile);    		// ausdrucken der aktuellen Zeile

		linecount++;				// Zeilenzähler incrementieren
		printf("\rZeile %d",linecount);		// Zeilennummer ausgeben
		}
	}


	fclose(out);                    		// schlie8en der Datei auf die "out" zeigt
	fclose(in);		        		// schlie8en der Datei auf die "in" zeigt


        printf("\n all done\n");
	return 0;
}

